## ruby-libv8-node 18.19.1.0

=== Makefile ===
PWD := $(shell pwd)
OS := $(shell uname -s | tr '[A-Z]' '[a-z]')
CPU := $(shell uname -m)
VERSION := $(shell ./libexec/metadata version)
NODE_VERSION := $(shell ./libexec/metadata node_version)
RUBY_VERSION = $(shell ruby -e 'puts RUBY_VERSION.gsub(/\d+$$/, "0")')

.PHONY: vars
vars:
	@echo $(PWD)
	@echo $(OS) $(CPU)
	@echo $(VERSION) $(NODE_VERSION)
	@echo $(RUBY_VERSION)

.PHONY: all
all: gem test

.PHONY: build
build: src/node-v$(NODE_VERSION)/out/Release/node

.PHONY: lib
lib: src/node-v$(NODE_VERSION)/out/Release/libv8_monolith.a

.PHONY: gem
gem: pkg/libv8-node-$(VERSION)-$(CPU)-$(OS).gem

.PHONY: test
test: test/$(CPU)-$(OS)

.PHONY: ctest
ctest: vendor/v8
	cd test/gtest && cmake -S . -B build && cd build && cmake --build . && ctest

src/node-v$(NODE_VERSION).tar.gz:
	./libexec/download-node $(NODE_VERSION)

src/node-v$(NODE_VERSION): src/node-v$(NODE_VERSION).tar.gz
	./libexec/extract-node $(NODE_VERSION)

src/node-v$(NODE_VERSION)/out/Release/node: src/node-v$(NODE_VERSION)
	./libexec/build-libv8 $(NODE_VERSION)

src/node-v$(NODE_VERSION)/out/Release/libv8_monolith.a: src/node-v$(NODE_VERSION)/out/Release/node
	./libexec/build-monolith $(NODE_VERSION)

.PHONY: vendor/v8
vendor/v8: src/node-v$(NODE_VERSION)/out/Release/libv8_monolith.a
	./libexec/inject-libv8 $(NODE_VERSION)

pkg/libv8-node-$(VERSION)-$(CPU)-$(OS).gem: vendor/v8
	bundle exec rake binary

.PHONY: test/$(CPU)-$(OS)
test/$(CPU)-$(OS): pkg/libv8-node-$(VERSION)-$(CPU)-$(OS).gem
	test -d test/mini_racer || git clone https://github.com/rubyjs/mini_racer.git test/mini_racer --depth 1
	cd test/mini_racer && git fetch origin refs/pull/261/head && git checkout FETCH_HEAD && git reset --hard && git clean -f -d -x
	ruby -i -ne '$$_ =~ /^\s+LIBV8_NODE_VERSION/ ? print("  LIBV8_NODE_VERSION = \"$(VERSION)\"\n") : print' test/mini_racer/lib/mini_racer/version.rb
	ruby -i -ne '$$_ =~ /spec.required_ruby_version/ ? "" : print' test/mini_racer/mini_racer.gemspec
	cd test/mini_racer && env TOP="$(PWD)" GEM_HOME="$(PWD)/test/bundle/ruby/$(RUBY_VERSION)" BUNDLE_PATH="$(PWD)/test/bundle" sh -c 'rm -rf "$${GEM_HOME}" && gem install $${TOP}/$< && bundle install && bundle exec rake compile && bundle exec rake test'

=== gtest/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
project(gtest)

# GoogleTest requires at least C++14
set(CMAKE_CXX_STANDARD 14)

include(FetchContent)
FetchContent_Declare(
  googletest
  URL https://github.com/google/googletest/archive/03597a01ee50ed33e9dfd640b249b4be3799d395.zip
)
# For Windows: Prevent overriding the parent project's compiler/linker settings
set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
FetchContent_MakeAvailable(googletest)

enable_testing()

include_directories(${CMAKE_SOURCE_DIR}/../../vendor/v8/include/)

add_executable(
  c_v8_tests
  c_v8_tests.cc
)
target_link_libraries(
  c_v8_tests
  GTest::gtest_main
)

string(TOLOWER ${CMAKE_SYSTEM_NAME} system_name)
string(TOLOWER ${CMAKE_SYSTEM_PROCESSOR} system_arch)

set(vendor_arch "${system_arch}-${system_name}")

if(${system_name} STREQUAL "linux")
	try_compile(is_glibc ${CMAKE_BINARY_DIR}/check_glibc ${CMAKE_SOURCE_DIR}/check_glibc.c)
	if(NOT is_glibc)
		# assume non-glibc is musl-libc
		string(APPEND vendor_arch "-musl")
	endif()
endif()

message(STATUS "Detected vendor architecture directory: ${vendor_arch}")

# TODO?: Detect and support ruby-arch builds?
target_link_libraries(c_v8_tests ${CMAKE_SOURCE_DIR}/../../vendor/v8/${vendor_arch}/libv8/obj/libv8_monolith.a)

# This has to be after the v8 monolith for some build setups.
target_link_libraries(c_v8_tests dl)

include(GoogleTest)
gtest_discover_tests(c_v8_tests)

=== debian/changelog ===
ruby-libv8-node (18.19.1.0-0kali2) kali-dev; urgency=medium

  * Clean packaging

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 26 Feb 2025 13:46:49 +0100

ruby-libv8-node (18.19.1.0-0kali1) kali-dev; urgency=medium

  * Initial release

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 19 Feb 2025 16:13:28 +0100

=== debian/control ===
Source: ruby-libv8-node
Section: ruby
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Sophie Brun <sophie@offensive-security.com>
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               ca-certificates,
               gem2deb (>= 1.6~),
	       python3,
	       python3-setuptools,
               rake,
	       wget
Standards-Version: 4.7.0
Vcs-Git: https://gitlab.com/kalilinux/packages/ruby-libv8-node.git
Vcs-Browser: https://gitlab.com/kalilinux/packages/ruby-libv8-node
Homepage: https://github.com/rubyjs/libv8-node
Testsuite: autopkgtest-pkg-ruby
Rules-Requires-Root: no

Package: ruby-libv8-node
Architecture: amd64
Depends: ${misc:Depends},
         ${ruby:Depends},
         ${shlibs:Depends}
Description: Node.JS's V8 JavaScript engine
 Node.JS's V8 JavaScript engine for multiplatform goodness

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export GEM2DEB_TEST_RUNNER = --check-dependencies
export DH_RUBY = --gem-install
export RUBYVERSION = $(shell echo $$(ruby -v | cut -d ' ' -f 2 | cut -d '.' -f 1-2)'.0')
export DEB_VERSION_UPSTREAM


%:
	dh $@ --buildsystem=ruby --with ruby

override_dh_strip:
#	do not run dh_strip, it fails with
#	strip: debian/ruby-libv8-node/usr/lib/x86_64-linux-gnu/rubygems-integration/3.3.0/gems/libv8-node-18.19.1.0/vendor/v8/x86_64-linux-gnu/libv8/obj/styTSJlg/./v8_initializers/gen/torque-generated/test/torque/test-torque-tq-csa.o: No such file or directory

=== debian/watch ===
version=4
https://gemwatch.debian.net/libv8-node .*/libv8-node-(.*).tar.gz

# Use the regex below for github-based sources
# opts=uversionmangle=s/[_.+-]?(rc|pre|dev|beta|alpha|b|a)/~$1/i,\
# filenamemangle=s%(?:.+/)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2% \
#   https://github.com/<owner>/<repo>/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
